UrlRequest

public abstract class UrlRequest


Controls an HTTP request (GET, PUT, POST etc). Created by UrlRequest.Builder, which can be obtained by calling newUrlRequestBuilder. Note: All methods must be called on the Executor passed to newUrlRequestBuilder.

Summary

Nested types

public abstract class UrlRequest.Builder

Builder for UrlRequests.

public abstract class UrlRequest.Callback

Users of Cronet extend this class to receive callbacks indicating the progress of a UrlRequest being processed.

An annotation for APIs which are not considered stable yet.

public class UrlRequest.Status

Request status values returned by getStatus.

public abstract class UrlRequest.StatusListener

Listener class used with getStatus to receive the status of a UrlRequest.

Public constructors

Public methods

abstract void

Cancels the request.

abstract void

Follows a pending redirect.

abstract void

Queries the status of the request.

abstract boolean

Returns true if the request was successfully started and is now finished (completed, canceled, or failed).

abstract void
read(ByteBuffer buffer)

Attempts to read part of the response body into the provided buffer.

abstract void

Starts the request, all callbacks go to Callback.

Public constructors

UrlRequest

public UrlRequest()

Public methods

cancel

public abstract void cancel()

Cancels the request. Can be called at any time. onCanceled() will be invoked when cancellation is complete and no further callback methods will be invoked. If the request has completed or has not started, calling cancel() has no effect and onCanceled() will not be invoked. If the Executor passed in during UrlRequest construction runs tasks on a single thread, and cancel() is called on that thread, no callback methods (besides onCanceled()) will be invoked after cancel() is called. Otherwise, at most one callback method may be invoked after cancel() has completed.

followRedirect

public abstract void followRedirect()

Follows a pending redirect. Must only be called at most once for each invocation of onRedirectReceived().

getStatus

public abstract void getStatus(UrlRequest.StatusListener listener)

Queries the status of the request.

Parameters
UrlRequest.StatusListener listener

a StatusListener that will be invoked with the request's current status. listener will be invoked back on the Executor passed in when the request was created.

isDone

public abstract boolean isDone()

Returns true if the request was successfully started and is now finished (completed, canceled, or failed).

Returns
boolean

true if the request was successfully started and is now finished (completed, canceled, or failed).

read

public abstract void read(ByteBuffer buffer)

Attempts to read part of the response body into the provided buffer. Must only be called at most once in response to each invocation of the onResponseStarted() and onReadCompleted() methods of the Callback. Each call will result in an asynchronous call to either the Callback'sonReadCompleted() method if data is read, its onSucceeded() method if there's no more data to read, or its onFailed() method if there's an error.

Parameters
ByteBuffer buffer

ByteBuffer to write response body to. Must be a direct ByteBuffer. The embedder must not read or modify buffer's position, limit, or data between its position and limit until the request calls back into the Callback.

start

public abstract void start()

Starts the request, all callbacks go to Callback. May only be called once. May not be called if cancel has been called.